/*
Name:		Motorkontroller.ino
Created:	28/11/2017 14:09:36
Author:	egode
*/
#define Rot1 2
#define M1dir 3

//setter opp register PB 0-3 som motor pinner og bruker registerene i stede. 
#define pos1 0b1001
#define pos2 0b1010
#define pos3 0b0110
#define pos4 0b0101
/*
#define M1 9
#define M2 10
#define M3 11
#define M4 12
*/
void setup() {
	Serial.begin(9600);
	DDRB |= 0x0F;
	//pinmode(m1, output);
	//pinmode(m2, output);
	//pinmode(m3, output);
	//pinmode(m4, output);
	pinMode(M1dir, INPUT);
	pinMode(Rot1, INPUT);
}

void loop() {
	//digitalWrite(enableO1, digitalRead(enable1));
	//digitalWrite(enableO2, digitalRead(enable2));
	//digitalWrite(enableO3, digitalRead(enable3));

	if (digitalRead(Rot1)) {
		if (digitalRead(Rot1) == 1) {
			stepCW();
		}
		else
		{
			stepCCW();
		}

		while (digitalRead(Rot1)) {};
	}

}
void stepCW() {
	int pos = 0;
	pos = PORTB & 0x0F;
	switch (pos) {
	case pos4:
		PORTD = (PORTB & 0x0f) | (pos1 << 4);
		PORTB = (PORTB & 0xf0) | (pos1);
		/*
		digitalWrite(M1, 1);
		digitalWrite(M2, 0);
		digitalWrite(M3, 0);
		digitalWrite(M4, 1);
		*/
		break;

	case pos1:
		PORTD = (PORTB & 0x0f) | (pos2 << 4);
		PORTB = (PORTB & 0xf0) | (pos2);
		/*
		digitalWrite(M1, 1);
		digitalWrite(M2, 0);
		digitalWrite(M3, 1);
		digitalWrite(M4, 0);
		*/break;

	case pos2:
		PORTB = (PORTB & 0xf0) | (pos3);
		PORTD = (PORTB & 0x0f) | (pos3 << 4);
		/*
		digitalWrite(M1, 0);
		digitalWrite(M2, 1);
		digitalWrite(M3, 1);
		digitalWrite(M4, 0);
		*/
		break;
	case pos3:
		PORTD = (PORTB & 0x0f) | (pos4 << 4);
		PORTB = (PORTB & 0xf0) | (pos4);
		/*

		digitalWrite(M1, 0);
		digitalWrite(M2, 1);
		digitalWrite(M3, 0);
		digitalWrite(M4, 1);
		*/
		break;

	default:
		PORTB = 5;//(PORTB & 0xf0) | (pos4);
				  /*
				  digitalWrite(M1, 1);
				  digitalWrite(M2, 0);
				  digitalWrite(M3, 1);
				  digitalWrite(M4, 0);
				  */
		break;
	}

}
void stepCCW() {
	int pos = 0;
	pos = PORTB & 0x0F;
	switch (pos) {
	case pos2:
		PORTB = (PORTB & 0xf0) | (pos1);
		/*
		digitalWrite(M1, 1);
		digitalWrite(M2, 0);
		digitalWrite(M3, 0);
		digitalWrite(M4, 1);
		*/
		break;

	case pos3:
		PORTB = (PORTB & 0xf0) | (pos2);
		/*
		digitalWrite(M1, 1);
		digitalWrite(M2, 0);
		digitalWrite(M3, 1);
		digitalWrite(M4, 0);
		*/break;

	case pos4:
		PORTB = (PORTB & 0xf0) | (pos3);
		/*
		digitalWrite(M1, 0);
		digitalWrite(M2, 1);
		digitalWrite(M3, 1);
		digitalWrite(M4, 0);
		*/
		break;
	case pos1:
		PORTB = (PORTB & 0xf0) | (pos4);
		/*

		digitalWrite(M1, 0);
		digitalWrite(M2, 1);
		digitalWrite(M3, 0);
		digitalWrite(M4, 1);
		*/
		break;

	default:
		PORTB = 5;//(PORTB & 0xf0) | (pos4);
				  /*
				  digitalWrite(M1, 1);
				  digitalWrite(M2, 0);
				  digitalWrite(M3, 1);
				  digitalWrite(M4, 0);
				  */
		break;
	}


}

void stepannyway() {
	stepCCW;
	delayMicroseconds(1000);
}